CREATE PROCEDURE [dbo].[GET_SPEXOrderRAWData_1_24012019] 
	@MANIFEST_NO VARCHAR(20),
	@ORDER_DATE VARCHAR(15),
	@SUPP_CD VARCHAR(6),
	@SUPP_PLANT_CD VARCHAR(4)
AS BEGIN
	
	DECLARE @ORDER_QTY INT = 0
	IF OBJECT_ID('tempdb..#dps') IS NOT NULL 
		DROP TABLE #dps

	DECLARE @SUB_SUPP_CD VARCHAR(6),
			@SUB_SUPP_PLANT VARCHAR(3),
			@SUB_SUPP_NAME VARCHAR(MAX)
	DECLARE @ROWS INT = 0,
			@SUM_ORDER_QTY INT = 0,
			@ROWS_STR VARCHAR(10),
			@SUM_STR VARCHAR(10),
			@SUB_SUPP_SPECIAL_SYSTEM VARCHAR(MAX)
	CREATE TABLE #SUB_SUPP_SPECIAL (SUB_SUPP_CD_SPECIAL VARCHAR(100))
	
	SELECT @SUB_SUPP_SPECIAL_SYSTEM = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE FUNCTION_ID = 'SPEX_ORDER' AND SYSTEM_CD = 'SUB_SUPP'
	INSERT INTO #SUB_SUPP_SPECIAL
	SELECT s from dbo.fnSplitString(@SUB_SUPP_SPECIAL_SYSTEM, ';')

	IF OBJECT_ID('tempdb..#dps_out') IS NOT NULL 
		DROP TABLE #dps_out
	CREATE TABLE #dps_out (DATA VARCHAR(MAX))

	SELECT 
		 ISNULL(m.MANIFEST_NO, '') + '|' + --0
		 ISNULL(CASE WHEN ISNULL(m.SUB_SUPP_CD, '') <> '' THEN m.SUB_SUPP_CD ELSE s.SUPPLIER_CODE END, '') + '|' +
		 ISNULL(CASE WHEN ISNULL(m.SUB_SUPP_CD, '') <> '' THEN m.SUB_SUPP_PLANT ELSE s.SUPPLIER_PLANT_CD END, '') + '|' +
		 ISNULL(case when REPLACE(m.SHIPPING_DOCK,' ','') <> '' then m.SHIPPING_DOCK else '' end, '') + '|' + --SHIPPING_DOCK
		 ISNULL(m.COMPANY_CD, '') + '|' +
		 ISNULL(p.RCV_PLANT_CD, '') + '|' +
		 ISNULL(p.DOCK_CD, '') + '|' +
		 ISNULL(m.ORDER_NO, '') + '|' +
		 ISNULL(case when REPLACE(m.CAR_FAMILY_CD,' ','') <> '' then m.CAR_FAMILY_CD else '' end, '') + '|' + --CAR_FAMILY_CD
		 ISNULL(case when REPLACE(m.RE_EXPORT_CD,' ','') <> '' then m.RE_EXPORT_CD else '' end, '') + '|' + --RE_EXPORT_CD
		 ISNULL(p.PART_NO, '') + '|' +
		 ISNULL(p.KANBAN_PRINT_ADDRESS, '') + '|' +
		 ISNULL(m.ORDER_TYPE, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), m.ORDER_RELEASE_DT, 121), '') + '|' + --ORDER_RELEASE_DT
		 ISNULL(p.KANBAN_NO, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(100),p.QTY_PER_CONTAINER), '') + '|' +
		 ISNULL(CONVERT(VARCHAR(100),p.QTY_PER_CONTAINER), '') + '|' + --ORDER_QTY
		 ISNULL(CONVERT(VARCHAR(100),p.QTY_PER_CONTAINER), '') + '|' + --ORDER_PLAN_QTY_LOT
		 ISNULL(CONVERT(VARCHAR(100), p.BUILD_OUT_FLAG), '') + '|' +
		 ISNULL(CONVERT(VARCHAR(10),p.BUILD_OUT_QTY), '') + '|' +
		 ISNULL(CONVERT(VARCHAR(10),p.AICO_CEPT_FLAG), '') + '|' +
		 ISNULL(CASE WHEN ISNULL(m.SUB_SUPP_CD, '') <> '' THEN ssp.SUB_SUPP_NAME ELSE p.SUPPLIER_NAME END, '') + '|' +
		 ISNULL(p.PART_NAME, '') + '|' +
		 ISNULL(p.ORDER_MODE, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), m.SHIPPING_DT, 121), '') + '|' + --SHIPPING_DT
		 ISNULL(CONVERT(VARCHAR(23), m.ARRIVAL_PLAN_DT, 121), '') + '|' + --ARRIVAL_DT
		 ISNULL(m.P_LANE_CD, '') + '|' +
		 ISNULL(m.P_LANE_SEQ, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), m.P_LANE_DT, 121), '') + '|' + --P_LANE_DT
		 ISNULL(m.SUB_ROUTE_CD, '') + '|' +
		 ISNULL(m.SUB_ROUTE_SEQ, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), m.SUB_ROUTE_DT, 121), '') + '|' + --SUB_ROUTE_DT
		 ISNULL(m.FST_X_DOC_CD, '') + '|' +
		 ISNULL(m.FST_X_PLANT_CD, '') + '|' +
		 ISNULL(m.FST_X_SHIPPING_DOCK_CD, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), m.FST_X_DOCK_ARRIVAL_DT, 121), '') + '|' + --FST_X_DOCK_ARRIVAL_DT
		 ISNULL(CONVERT(VARCHAR(23), m.FST_X_DOCK_DEPART_DT, 121), '') + '|' + --FST_X_DOCK_DEPART_DT
		 ISNULL(m.FST_X_DOCK_ROUTE_GRP_CD, '') + '|' +
		 ISNULL(m.FST_X_DOCK_SEQ_NO, '') + '|' +
		 ISNULL(m.fst_x_route_dt, '') + '|' +
		 ISNULL(m.SND_X_DOC_CD, '') + '|' +
		 ISNULL(m.SND_X_PLANT_CD, '') + '|' +
		 ISNULL(m.SND_X_SHIPPING_DOCK_CD, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), m.SND_X_DOCK_ARRIVAL_DT, 121), '') + '|' + --SND_X_DOCK_ARRIVAL_DT
		 ISNULL(CONVERT(VARCHAR(23), m.SND_X_DOCK_DEPART_DT, 121), '') + '|' + --SND_X_DOCK_DEPART_DT
		 ISNULL(m.SND_X_DOCK_ROUTE_GRP_CD, '') + '|' +
		 ISNULL(m.SND_X_DOCK_SEQ_NO, '') + '|' +
		 ISNULL(m.TRD_X_DOC_CD, '') + '|' +
		 ISNULL(m.TRD_X_PLANT_CD, '') + '|' +
		 ISNULL(m.TRD_X_SHIPPING_DOCK_CD, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), m.TRD_X_DOCK_ARRIVAL_DT, 121), '') + '|' + --TRD_X_DOCK_ARRIVAL_DT
		 ISNULL(CONVERT(VARCHAR(23), m.TRD_X_DOCK_DEPART_DT, 121), '') + '|' + --TRD_X_DOCK_DEPART_DT
		 ISNULL(m.TRD_X_DOCK_ROUTE_GRP_CD, '') + '|' +
		 ISNULL(m.TRD_X_DOCK_SEQ_NO, '') + '|' +
		 ISNULL(m.trd_x_route_dt, '') + '|' +
		 ISNULL(m.MANIFEST_PRINT_POINT_CD, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), m.MANIFEST_PRINT_DATE_PLANT, 121), '') + '|' + --MANIFEST_PRINT_DATE_PLANT
		 ISNULL(CONVERT(VARCHAR(23), m.MANIFEST_PRINT_DATE_LOCAL, 121), '') + '|' + --MANIFEST_PRINT_DATE_LOCAL
		 ISNULL(p.KANBAN_PRINT_POINT_CD, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), p.KANBAN_PRINT_DATE_PLANT, 121), '') + '|' + --KANBAN_PRINT_DATE_PLANT
		 ISNULL(CONVERT(VARCHAR(23), p.KANBAN_PRINT_DATE_LOCAL, 121), '') + '|' + --KANBAN_PRINT_DATE_LOCAL
		 ISNULL(p.CONVEYANCE_ROUTE, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(23), p.FERRY_PORT_ARRIVAL_DT, 121), '') + '|' + --FERRY_PORT_ARRIVAL_DT
		 ISNULL(CONVERT(VARCHAR(23), p.FERRY_PORT_DEPART_DT, 121), '') + '|' + --FERRY_PORT_DEPART_DT
		 ISNULL(CONVERT(VARCHAR(10),m.PRINT_FLAG), '0') + '|' + --PRINT_FLAG
		 ISNULL(CONVERT(VARCHAR(23), m.PRINT_DATE, 121), '') + '|' + --PRINT_DATE
		 ISNULL(CONVERT(VARCHAR(10),m.RECEIVE_FLAG), '0') + '|' + --RECEIVE_FLAG
		 ISNULL(CONVERT(VARCHAR(23), m.RECEIVE_DT, 121), '') + '|' + --RECEIVE_DT
		 ISNULL(CONVERT(VARCHAR(10),m.USAGE_FLAG), '0') + '|' + --USAGE_FLAG
		 ISNULL(CONVERT(VARCHAR(23), m.USAGE_DT, 121), '') + '|' + --USAGE_DT
		 ISNULL(CONVERT(VARCHAR(10),m.DELETION_FLAG), '0') + '|' + --DELETION_FLAG
		 ISNULL(CONVERT(VARCHAR(23), m.DELETION_DT, 121), '') + '|' + --DELETION_DT
		 ISNULL(CONVERT(VARCHAR(10),m.DROP_STATUS_FLAG), '0') + '|' + --DROP_STATUS_FLAG
		 ISNULL(CONVERT(VARCHAR(23), m.DROP_STATUS_DT, 121), '') + '|' + --DROP_STATUS_DT
		 ISNULL(CONVERT(VARCHAR(23),np.RECEIVED_QTY), '0') + '|' + --RECEIVED_QTY
		 ISNULL(CONVERT(VARCHAR(10),m.ICS_FLAG), '0') + '|' + --SAPFlag
		 ISNULL(CONVERT(VARCHAR(23), m.ICS_DT, 121), '') + '|' + --SAPDate
		 ISNULL(CONVERT(VARCHAR(100),m.TOTAL_PAGE), '') + '|' +
		 ISNULL(CONVERT(VARCHAR(10),p.EKBS_FLAG), '0') + '|' + --EKBS_FLAG
		 ISNULL(CONVERT(VARCHAR(23), p.EKBS_DT, 121), '') + '|' + --EKBS_DT
		 ISNULL(CONVERT(VARCHAR(10), m.PAT_DP_FLAG), '') + '|' +
		 ISNULL(CONVERT(VARCHAR(10), m.PAT_PL_FLAG), '') + '|' +
		 ISNULL(p.RECEIVE_PLANT_NAME, '') + '|' +
		 ISNULL(p.PACKAGE_TYPE, '') + '|' +
		 ISNULL(p.SUPPLIER_INFO1, '') + '|' +
		 ISNULL(p.SUPPLIER_INFO2, '') + '|' +
		 ISNULL(p.SUPPLIER_INFO3, '') + '|' +
		 ISNULL(p.PRINT_CD, '') + '|' +
		 ISNULL(p.IMPORTIR_INFO, '') + '|' +
		 ISNULL(p.IMPORTIR_INFO2, '') + '|' +
		 ISNULL(p.IMPORTIR_INFO3, '') + '|' +
		 ISNULL(p.IMPORTIR_INFO4, '') + '|' +
		 ISNULL(CASE WHEN ISNULL(kb.PART_BARCODE, '') = '' THEN p.PART_BARCODE ELSE kb.PART_BARCODE END, '') + '|' +
		 ISNULL(p.MOD_DST_CD, '') + '|' +
		 ISNULL(p.case_no, '') + '|' +
		 ISNULL(CONVERT(VARCHAR(10),p.PLN_PCK_DT,103), '') + '|' + --PLN_PCK_DT
		 ISNULL(p.BOX_NO, '') + '|' +
		 ISNULL(p.CONT_SNO, '') + '|' +
		 ISNULL(p.PROCESS_TYPE, '') + '|' +
		 --ISNULL(p.LOT_MOD_NO, '') as DATA,
		 ISNULL(m.REMARKS, '') +
		 CASE WHEN ISNULL(m.SUB_SUPP_CD, '') IN (SELECT SUB_SUPP_CD_SPECIAL FROM #SUB_SUPP_SPECIAL)
		 THEN
			ISNULL(CASE WHEN ISNULL(m.SUB_SUPP_CD, '') <> '' THEN '|' + s.SUPPLIER_CODE + '|' + s.SUPPLIER_PLANT_CD ELSE '' END, '')
		 ELSE '' END as DATA,
		 p.ORDER_QTY
	 INTO #dps
	 FROM TB_R_SPEX_DAILY_ORDER_MANIFEST m
	 INNER JOIN TB_R_SPEX_DAILY_ORDER_PART p ON p.MANIFEST_NO = m.MANIFEST_NO
	 INNER JOIN TB_M_SUPPLIER s ON s.SUPPLIER_CODE = m.SUPPLIER_CD AND s.SUPPLIER_PLANT_CD = m.SUPPLIER_PLANT
	 LEFT JOIN TB_M_SPEX_SUB_SUPPLIER ssp ON ssp.SUB_SUPP_CD = m.SUB_SUPP_CD AND ssp.SUB_SUPP_PLANT = m.SUB_SUPP_PLANT
	 INNER JOIN TB_R_SPEX_KANBAN kb on p.MANIFEST_NO=kb.MANIFEST_NO AND p.ITEM_NO = kb.ITEM_NO
	 LEFT JOIN TB_R_PROBLEM_PART np on p.MANIFEST_NO=np.MANIFEST_NO AND p.PART_NO=np.PART_NO
	 WHERE m.MANIFEST_NO = @MANIFEST_NO AND
	   CONVERT(VARCHAR(8),m.CREATED_DT,112) = @ORDER_DATE AND
	   m.SUPPLIER_CD = @SUPP_CD AND
	   m.SUPPLIER_PLANT = @SUPP_PLANT_CD
	 ORDER BY
	   m.SUPPLIER_CD
	 , m.SUPPLIER_PLANT
	 , ARRIVAL_PLAN_DT

	SELECT @ROWS = @@ROWCOUNT

	SELECT
		@SUB_SUPP_CD = m.SUB_SUPP_CD,
		@SUB_SUPP_PLANT = m.SUB_SUPP_PLANT,
		@SUB_SUPP_NAME = ssp.SUB_SUPP_NAME
	FROM TB_R_SPEX_DAILY_ORDER_MANIFEST m
		LEFT JOIN TB_M_SPEX_SUB_SUPPLIER ssp ON ssp.SUB_SUPP_CD = m.SUB_SUPP_CD AND ssp.SUB_SUPP_PLANT = m.SUB_SUPP_PLANT
	WHERE m.MANIFEST_NO = @MANIFEST_NO AND
	   CONVERT(VARCHAR(8),m.CREATED_DT,112) = @ORDER_DATE AND
	   m.SUPPLIER_CD = @SUPP_CD AND
	   m.SUPPLIER_PLANT = @SUPP_PLANT_CD

	SELECT @SUM_ORDER_QTY = SUM(ORDER_QTY) FROM (SELECT DISTINCT DATA, ORDER_QTY FROM #dps)TBL
	SELECT @ROWS_STR = RIGHT(REPLICATE('0', 8) + CONVERT(VARCHAR(MAX), @ROWS), 8)
	SELECT @SUM_STR = RIGHT(REPLICATE('0', 8) + CONVERT(VARCHAR(MAX), @SUM_ORDER_QTY), 8)

	--INSERT INTO #dps_out (DATA)
	SELECT lvl LVL, DATA FROM (
		SELECT 1 lvl, 
			ISNULL(CASE WHEN ISNULL(@SUB_SUPP_CD, '') <> '' THEN @SUB_SUPP_CD ELSE @SUPP_CD END, '') + '|' + 
			ISNULL(CASE WHEN ISNULL(@SUB_SUPP_CD, '') <> '' THEN @SUB_SUPP_PLANT ELSE @SUPP_PLANT_CD END, '') + '|' + 
			ISNULL(@ORDER_DATE, '') + '|' +
			ISNULL(@ROWS_STR, '') + '|' + 
			ISNULL(@SUM_STR, '') DATA
		UNION ALL
		SELECT DISTINCT 2 lvl, DATA FROM #dps
	)TBL
	ORDER BY lvl ASC

	--SELECT DATA FROM #dps_out
	 
	--SELECT DISTINCT DATA, ORDER_QTY FROM #dps
END

